(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define('pdeio-grid-list', ['exports', '@angular/core', '@angular/common', '@angular/router'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['pdeio-grid-list'] = {}, global.ng.core, global.ng.common, global.ng.router));
}(this, (function (exports, i0, common, router) { 'use strict';

    var GridListService = /** @class */ (function () {
        function GridListService() {
        }
        return GridListService;
    }());
    GridListService.ɵprov = i0.ɵɵdefineInjectable({ factory: function GridListService_Factory() { return new GridListService(); }, token: GridListService, providedIn: "root" });
    GridListService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    GridListService.ctorParameters = function () { return []; };

    var GridListComponent = /** @class */ (function () {
        function GridListComponent() {
            this.isList = false;
            this.ItemsPerPage = 10;
            this.thumbType = 'image';
            this.actionBtnClicked = new i0.EventEmitter();
            this.actionBtn2Clicked = new i0.EventEmitter();
            this.actionBtn3Clicked = new i0.EventEmitter();
            this.actionBtn4Clicked = new i0.EventEmitter();
            this.pageChanged = new i0.EventEmitter();
            this.page = 1;
            this.audios = [];
            this.audiosProgress = [];
        }
        GridListComponent.prototype.onActionBtnClick = function (item) {
            this.actionBtnClicked.next(item);
        };
        GridListComponent.prototype.onActionBtn2Click = function (item) {
            this.actionBtn2Clicked.next(item);
        };
        GridListComponent.prototype.onActionBtn3Click = function (item) {
            this.actionBtn3Clicked.next(item);
        };
        GridListComponent.prototype.onActionBtn4Click = function (item) {
            this.actionBtn4Clicked.next(item);
        };
        GridListComponent.prototype.onChangePage = function (page) {
            if (page) {
                this.pageChanged.next(page);
            }
        };
        GridListComponent.prototype.playAudio = function (src, index) {
            if (!this.audios[index]) {
                var audio = new Audio(src);
                this.audios.push(audio);
                this.audiosProgress[index] = 0;
            }
            else {
                if (this.audios[index].ended || this.audios[index].currentTime == 0) {
                    this.audiosProgress[index] = 0;
                }
            }
            this.audios[index].play();
            this.startTimer(index);
        };
        GridListComponent.prototype.pauseAudio = function (index) {
            this.audios[index].pause();
            clearTimeout(this.timer);
        };
        GridListComponent.prototype.reloadAudio = function (index) {
            this.audios[index].currentTime = 0;
            this.audiosProgress[index] = 0;
            clearTimeout(this.timer);
            this.audios[index].play();
            this.startTimer(index);
        };
        GridListComponent.prototype.advance = function (index) {
            var duration = this.audios[index].duration;
            var currentTime = this.audios[index].currentTime;
            var increment = 10 / duration;
            var percent = Math.min(increment * currentTime * 10, 100);
            this.audiosProgress[index] = percent;
            this.startTimer(index);
        };
        GridListComponent.prototype.startTimer = function (index) {
            if (this.audiosProgress[index] < 100) {
                var that_1 = this;
                this.timer = setTimeout(function () {
                    that_1.advance(index);
                    clearTimeout(this.timer);
                }, 1000);
            }
        };
        GridListComponent.prototype.removeAudio = function (index) {
            this.pauseAudio(index);
            this.audios[index] = null;
        };
        return GridListComponent;
    }());
    GridListComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-grid-list',
                    template: "<div class=\"row mx-0 mb-4 list-header\">\r\n  <div class=\"col-6\">\r\n    <div *ngIf=\"hasList\">\r\n      <button\r\n        class=\"btn btn-sm rounded-pill btn-outline-light btn-svg mr-2 {{\r\n          isList ? '' : 'active'\r\n        }}\"\r\n        (click)=\"isList = false\"\r\n      >\r\n        <svg\r\n          xml:space=\"preserve\"\r\n          xmlns:xlink=\"http://www.w3.org/1999/xlink\"\r\n          id=\"grid\"\r\n          style=\"enable-background: new 0 0 369.946 369.946\"\r\n          version=\"1.1\"\r\n          viewBox=\"0 0 369.946 369.946\"\r\n          width=\"16px\"\r\n          x=\"0px\"\r\n          xmlns=\"http://www.w3.org/2000/svg\"\r\n          y=\"0px\"\r\n        >\r\n          <path\r\n            d=\"M250.609,0h-11.934H131.271h-11.934H0v119.337v11.934v107.404v11.934v119.337h119.337h11.934\r\n        h107.404h11.934h119.337V250.609v-11.934V131.271v-11.934V0H250.609z M238.675,11.934v107.404H131.271V11.934H238.675z\r\n         M238.675,131.271v107.404H131.271V131.271H238.675z M11.934,11.934h107.404v107.404H11.934V11.934z M11.934,131.271h107.404\r\n        v107.404H11.934V131.271z M11.934,358.012V250.609h107.404v107.404H11.934z M131.271,358.012V250.609h107.404v107.404H131.271z\r\n         M358.012,358.012H250.609V250.609h107.404V358.012z M358.012,238.675H250.609V131.271h107.404V238.675z M250.609,119.337V11.934\r\n        h107.404v107.404H250.609z\"\r\n          ></path>\r\n        </svg>\r\n      </button>\r\n      <button\r\n        class=\"btn btn-sm btn-rounded rounded-pill btn-outline-light btn-svg {{\r\n          isList ? 'active' : ''\r\n        }}\"\r\n        (click)=\"isList = true\"\r\n      >\r\n        <svg\r\n          xml:space=\"preserve\"\r\n          xmlns:xlink=\"http://www.w3.org/1999/xlink\"\r\n          height=\"16px\"\r\n          id=\"list\"\r\n          style=\"enable-background: new 0 0 612 612\"\r\n          version=\"1.1\"\r\n          viewBox=\"0 0 612 612\"\r\n          width=\"16px\"\r\n          x=\"0px\"\r\n          xmlns=\"http://www.w3.org/2000/svg\"\r\n          y=\"0px\"\r\n        >\r\n          <path\r\n            d=\"M0,97.92v24.48h612V97.92H0z M0,318.24h612v-24.48H0V318.24z M0,514.08h612V489.6H0V514.08z\"\r\n          ></path>\r\n        </svg>\r\n      </button>\r\n    </div>\r\n  </div>\r\n  <div class=\"col-6 text-right\">\r\n    <span *ngIf=\"addBtn\" [routerLink]=\"addBtn.url\" [class]=\"addBtn.icon\"></span>\r\n  </div>\r\n</div>\r\n<div class=\"row mx-0 {{loading ? 'ghost' : ''}}\" *ngIf=\"data;\">\r\n  <div\r\n    class=\"list-item {{\r\n      isList ? 'list-horizontal col-12' : 'col-xl-3 col-sm-6 col-xs-12'\r\n    }}\"\r\n    style=\"min-width: 245px\"\r\n    *ngFor=\"let item of data; let i = index\"\r\n  >\r\n    <div\r\n      class=\"card o-hidden mb-4 d-flex {{\r\n        isList ? 'flex-row' : 'flex-column'\r\n      }}\"\r\n    >\r\n      <div class=\"list-thumb d-flex\">\r\n        <div *ngIf=\"thumbType === 'audio'\">\r\n          <div class=\"audioPlayer\">\r\n            <img alt=\"\" [src]=\"item.thumbUrl\" />\r\n            <div class=\"timeline\">\r\n              <div\r\n                class=\"soundline\"\r\n                [style]=\"\r\n                  'width:' + (audios[i] ? audiosProgress[i] : '0') + '%;'\r\n                \"\r\n              ></div>\r\n              <div class=\"controllers text-center d-flex\">\r\n                <div class=\"back\" (click)=\"reloadAudio(i)\"></div>\r\n                <div\r\n                  *ngIf=\"!audios[i] || audios[i].ended || audios[i].paused\"\r\n                  class=\"play\"\r\n                  (click)=\"playAudio(item.musicPath, i)\"\r\n                ></div>\r\n                <div\r\n                  *ngIf=\"audios[i] && !audios[i].paused && !audios[i].ended\"\r\n                  class=\"pause\"\r\n                  (click)=\"pauseAudio(i)\"\r\n                ></div>\r\n\r\n                <div\r\n                  *ngIf=\"!audios[i] || !audios[i].muted\"\r\n                  (click)=\"audios[i].muted = true\"\r\n                  class=\"volume\"\r\n                ></div>\r\n                <div\r\n                  *ngIf=\"audios[i] && audios[i].muted\"\r\n                  (click)=\"audios[i].muted = false\"\r\n                  class=\"mute\"\r\n                ></div>\r\n              </div>\r\n            </div>\r\n          </div>\r\n        </div>\r\n\r\n        <img *ngIf=\"thumbType === 'image'\" alt=\"\" [src]=\"item.thumbUrl\" />\r\n\r\n        <div\r\n          *ngIf=\"\r\n            !isList && (item.actionBtn || item.actionBtn2 || item.actionBtn3)\r\n          \"\r\n          class=\"thumb-overlay p-1 w-100 text-center\"\r\n        >\r\n          <a\r\n            *ngIf=\"item.actionBtn\"\r\n            [title]=\"item.actionBtn.tooltip\"\r\n            (click)=\"onActionBtnClick(item)\"\r\n            [routerLink]=\"item.actionBtn.url ? item.actionBtn.url : []\"\r\n            ><span class=\"{{ item.actionBtn.icon }}\"></span\r\n          ></a>\r\n          <a\r\n            *ngIf=\"item.actionBtn2\"\r\n            [title]=\"item.actionBtn2.tooltip\"\r\n            (click)=\"onActionBtn2Click(item)\"\r\n            [routerLink]=\"item.actionBtn2.url ? item.actionBtn2.url : []\"\r\n            ><span class=\"{{ item.actionBtn2.icon }}\"></span\r\n          ></a>\r\n          <a\r\n            *ngIf=\"item.actionBtn3\"\r\n            [title]=\"item.actionBtn3.tooltip\"\r\n            (click)=\"onActionBtn3Click(item)\"\r\n            [routerLink]=\"item.actionBtn3.url ? item.actionBtn3.url : []\"\r\n            ><span class=\"{{ item.actionBtn3.icon }}\"></span\r\n          ></a>\r\n          <a\r\n            *ngIf=\"item.actionBtn4\"\r\n            [title]=\"item.actionBtn4.tooltip\"\r\n            (click)=\"onActionBtn4Click(item)\"\r\n            [routerLink]=\"item.actionBtn4.url ? item.actionBtn4.url : []\"\r\n            ><span class=\"{{ item.actionBtn4.icon }}\"></span\r\n          ></a>\r\n        </div>\r\n      </div>\r\n      <div\r\n        class=\"{{ data.length == 1 ? 'mt-3' : '' }} flex-grow-1 {{\r\n          isList ? 'pl-2 d-flex' : 'd-block'\r\n        }}\"\r\n      >\r\n        <div\r\n          class=\"card-body align-self-center flex-column justify-content-between align-items-lg-center {{\r\n            isList ? 'd-flex flex-lg-row' : 'd-block'\r\n          }}\"\r\n        >\r\n          <a *ngIf=\"item.title\" class=\"w-40 w-sm-100\"\r\n            ><div class=\"text-truncate item-title\">\r\n              {{ item.title }}\r\n            </div></a\r\n          >\r\n          <p\r\n            *ngIf=\"item.description\"\r\n            title=\"{{ item.description }}\"\r\n            class=\"m-0 text-truncate text-muted text-small w-15 w-sm-100\"\r\n          >\r\n            {{ item.description }}\r\n          </p>\r\n          <p\r\n            *ngIf=\"item.description2\"\r\n            title=\"{{ item.description }}\"\r\n            class=\"m-0 text-truncatetext-muted text-small w-15 w-sm-100\"\r\n          >\r\n            {{ item.description2 }}\r\n          </p>\r\n          <p\r\n            *ngIf=\"item.description3\"\r\n            title=\"{{ item.description }}\"\r\n            class=\"m-0 text-truncate text-muted text-small w-15 w-sm-100\"\r\n          >\r\n            {{ item.description3 }}\r\n          </p>\r\n          <p\r\n            *ngIf=\"item.badgeLabel\"\r\n            [style.position]=\"isList ? 'inherit' : 'absolute'\"\r\n            class=\"m-0 text-truncate text-muted text-small w-15 w-sm-100 d-none d-lg-block {{\r\n              item.badgeLabel.position\r\n            }}\"\r\n          >\r\n            <span class=\"badge badge-{{ item.badgeLabel.color }} \">\r\n              {{ item.badgeLabel.label }}\r\n            </span>\r\n          </p>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n\r\n  <div class=\"col-12 mt-3 text-center\" *ngIf=\"pagination\">\r\n    <nav aria-label=\"Page navigation example\">\r\n      <ul class=\"pagination justify-content-center pagination-lg\">\r\n        <li class=\"page-item  {{!pagination.previousPage ? 'disabled': '' }}\">\r\n          <a class=\" pagination-previous\" (click)=\"onChangePage(pagination.previousPage)\" aria-label=\"Previous\">\r\n            <svg\r\n              xmlns=\"http://www.w3.org/2000/svg\"\r\n              xml:space=\"preserve\"\r\n              width=\"16px\"\r\n              height=\"23px\"\r\n              version=\"1.1\"\r\n              style=\"\r\n                shape-rendering: geometricPrecision;\r\n                text-rendering: geometricPrecision;\r\n                image-rendering: optimizeQuality;\r\n                fill-rule: evenodd;\r\n                clip-rule: evenodd;\r\n              \"\r\n              viewBox=\"0 0 16 22.63\"\r\n              xmlns:xlink=\"http://www.w3.org/1999/xlink\"\r\n              aria-hidden=\"true\"\r\n              focusable=\"false\"\r\n              role=\"img\"\r\n            >\r\n              <path\r\n                d=\"M2.45 10.56l8.59 -8.58c0.41,-0.42 1.08,-0.42 1.5,0l1 1c0.41,0.41 0.41,1.08 0,1.5l-6.81 6.83 6.81 6.84c0.41,0.42 0.41,1.09 0,1.5l-1 1c-0.42,0.42 -1.09,0.42 -1.5,0l-8.59 -8.59c-0.42,-0.41 -0.42,-1.08 0,-1.5l0 0z\"\r\n              />\r\n            </svg>\r\n          </a>\r\n        </li>\r\n        <li *ngIf=\"pagination.previousPage\" class=\"page-item\" (click)=\"onChangePage(pagination.previousPage)\"><a >{{pagination.previousPage}}</a></li>\r\n        <li class=\"page-item current\"><a >{{pagination.currentPage}}</a></li>\r\n        <li  *ngIf=\"pagination.nextPage\"><a (click)=\"onChangePage(pagination.nextPage)\">{{pagination.nextPage}}</a></li>\r\n        <li class=\"page-item {{!pagination.nextPage ? 'disabled': '' }}\">\r\n          <a class=\"pagination-next\" (click)=\"onChangePage(pagination.nextPage)\" aria-label=\"Next\">\r\n            <svg\r\n              xmlns=\"http://www.w3.org/2000/svg\"\r\n              xml:space=\"preserve\"\r\n              width=\"16px\"\r\n              height=\"23px\"\r\n              version=\"1.1\"\r\n              style=\"\r\n                shape-rendering: geometricPrecision;\r\n                text-rendering: geometricPrecision;\r\n                image-rendering: optimizeQuality;\r\n                fill-rule: evenodd;\r\n                clip-rule: evenodd;\r\n              \"\r\n              viewBox=\"0 0 16 22.63\"\r\n              xmlns:xlink=\"http://www.w3.org/1999/xlink\"\r\n              aria-hidden=\"true\"\r\n              focusable=\"false\"\r\n              role=\"img\"\r\n            >\r\n              <path\r\n                d=\"M13.54 12.06l-8.59 8.59c-0.41,0.42 -1.08,0.42 -1.5,0l-1 -1c-0.41,-0.41 -0.42,-1.08 0,-1.5l6.8 -6.84 -6.8 -6.83c-0.42,-0.42 -0.41,-1.09 0,-1.5l1 -1c0.42,-0.42 1.09,-0.42 1.5,0l8.59 8.58c0.41,0.42 0.41,1.09 0,1.5z\"\r\n              />\r\n            </svg>\r\n          </a>\r\n        </li>\r\n      </ul>\r\n    </nav>\r\n  </div>\r\n</div>\r\n",
                    styles: ["@charset \"UTF-8\";.list-header{margin-top:2rem}.list-header .bt-add{cursor:pointer}.list-header .btn.btn-outline-light.btn-svg.active,.list-header .btn.btn-outline-light.btn-svg:hover{background:#639;border-color:#639}.list-header .btn.btn-outline-light.btn-svg.active svg,.list-header .btn.btn-outline-light.btn-svg:hover svg{fill:#fff}.list-header .btn.btn-outline-light.btn-svg{padding:.2rem .6rem .3rem;border-color:#665c70}.list-item :active,.list-item a,.list-item a:focus{text-decoration:none;color:inherit}.list-item .list-thumb .thumb-overlay{position:absolute;top:150px;right:0;bottom:0;left:0;color:#fff;height:30px;background:rgba(0,0,0,.5)}.list-item .list-thumb .thumb-overlay a{cursor:pointer;margin-left:5px}.list-item .list-thumb .thumb-overlay a,.list-item .list-thumb .thumb-overlay a:active,.list-item .list-thumb .thumb-overlay a:focus{text-decoration:none;color:inherit}.list-item .list-thumb img{width:100%;height:180px;-o-object-fit:cover;object-fit:cover}.list-item .topLeft{top:16px;left:16px}.list-item .topRight{top:16px;right:16px}.list-item .bottomLeft{bottom:100px;left:16px}.list-item .bottomRight{bottom:100px;right:16px}.list-item .card{border-radius:10px;box-shadow:0 4px 20px 1px rgba(0,0,0,.06),0 1px 4px rgba(0,0,0,.08);border:0}.list-item .card .card-body a{color:#47404f}.list-item .card .item-title{white-space:nowrap!important;overflow:hidden!important;text-overflow:ellipsis!important;max-width:300px}.list-item .o-hidden{overflow:hidden}.list-item.list-horizontal a{color:#47404f}.list-item.list-horizontal a .item-title{width:150px}.list-item.list-horizontal .list-thumb img{height:74px;width:111px}.audioPlayer .timeline .controllers{margin:auto;width:75%}.audioPlayer .timeline .controllers .back,.audioPlayer .timeline .controllers .forward,.audioPlayer .timeline .controllers .mute,.audioPlayer .timeline .controllers .pause,.audioPlayer .timeline .controllers .play,.audioPlayer .timeline .controllers .volume{font-size:16px;margin:10px;color:#4a4a4a;width:40px;height:40px;border-radius:50%;border:1px solid transparent;cursor:pointer}.audioPlayer .timeline .controllers .back:after{content:\"\uF04A\";font-family:FontAwesome;margin-right:5px}.audioPlayer .timeline .controllers .play:after{content:\"\uF04B\";font-family:FontAwesome;margin-left:5px}.audioPlayer .timeline .controllers .mute:after{content:\"\uF026\";font-family:FontAwesome;margin-left:5px}.audioPlayer .timeline .controllers .volume:after{content:\"\uF028\";font-family:FontAwesome;margin-left:5px}.audioPlayer .timeline .controllers .forward:after{content:\"\uF04E\";font-family:FontAwesome;margin-left:5px}.audioPlayer .timeline .controllers .pause:after{content:\"\uF04C\";font-family:FontAwesome;margin-left:5px}.audioPlayer .timeline .soundline{width:100%;height:6px;position:relative;background:#2e2e8d;border-radius:2px;overflow:hidden}.audioPlayer .timeline .soundline:after{display:block;position:absolute;content:\"\";top:0;left:0;width:0;height:100%;background:#6ce59c;box-shadow:0 0 9px #94ffbf;transition:all .4s cubic-bezier(.07,.82,.11,1.02);-webkit-animation:soundline 20s linear infinite both;animation:soundline 20s linear infinite both}.pagination{-webkit-touch-callout:none;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.pagination li.disabled a{cursor:not-allowed}.pagination li.disabled svg{fill:#c2baca}.pagination li:not(.pagination-previous):not(.pagination-next){border:none;background:0 0;border-radius:50%!important;margin:0 4px!important;text-align:center;height:36px;width:36px;padding:0;display:flex;align-items:center;justify-content:center}.pagination li:not(.pagination-previous):not(.pagination-next).current{border:1px solid #639;background:#639}.pagination li:not(.pagination-previous):not(.pagination-next).current a{color:#fff}.pagination a,.pagination a:focus,.pagination a:hover,.pagination a:visited{color:#000;border:none;text-decoration:none;cursor:pointer}.pagination svg{fill:#639}.ghost *{color:transparent!important;text-shadow:0 0 5px rgba(0,0,0,.5)!important;filter:blur(2px);-webkit-filter:blur(2px)}"]
                },] }
    ];
    GridListComponent.ctorParameters = function () { return []; };
    GridListComponent.propDecorators = {
        data: [{ type: i0.Input }],
        hasList: [{ type: i0.Input }],
        loading: [{ type: i0.Input }],
        isList: [{ type: i0.Input }],
        addBtn: [{ type: i0.Input }],
        pagination: [{ type: i0.Input }],
        ItemsPerPage: [{ type: i0.Input }],
        thumbType: [{ type: i0.Input }],
        actionBtnClicked: [{ type: i0.Output }],
        actionBtn2Clicked: [{ type: i0.Output }],
        actionBtn3Clicked: [{ type: i0.Output }],
        actionBtn4Clicked: [{ type: i0.Output }],
        pageChanged: [{ type: i0.Output }]
    };

    var GridListModule = /** @class */ (function () {
        function GridListModule() {
        }
        return GridListModule;
    }());
    GridListModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [GridListComponent],
                    imports: [
                        common.CommonModule,
                        router.RouterModule
                    ],
                    exports: [GridListComponent]
                },] }
    ];

    /*
     * Public API Surface of grid-list
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.GridListComponent = GridListComponent;
    exports.GridListModule = GridListModule;
    exports.GridListService = GridListService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=pdeio-grid-list.umd.js.map
